︠3dceb69b-ecda-42a1-872e-999427eac1d9s︠
#Now identify the primes
#ulam spiral

# find n, given coords, first normalized
# so that (0,0)-->1, (1,0)-->2, (1,1)-->3, etc.
def pointToNum(x,y):
    if (x==0) & (y==0):
         return 1
    #first determine quadrant based on y= x, y=-x
    if (y>-x) & (y<=x):
        q=3
    if (y>x) & (y>=-x):
        q=2
   
    if (y<x) & (y<=-x):
        q=0
    if (y<-x) & (y>=x):
        q=1
    
    #next, determine which concentric square level we are at
    a = max(abs(x),abs(y))
    
    #list the coordinates of each corner point
    corners = [[a,-a],[-a,-a],[-a,a],[a,a]]
    
    #find the value of each quadrants corner point. 
    #start with southeast corner (#0) se
    se=(2*a+1)^2
    cornerVals=[se, se-2*a, se-4*a, se-6*a]
    
    #now find taxicab distance from given point to corner point
    dist = abs(x-corners[q][0]) + abs(y-corners[q][1])
    
    #finally, subtract this from corner value
    return  cornerVals[q]-dist
    
# Now we make a matrix of size 2a+1 where the origin (0,0) is now (a,a).
# Hence the point (x,y) in matrix coords (with (0,0) at lower left)
# will be translated to (x-a, y-a) for pointToNum computation

a= 30
# Make a value array
ulamArrayVals = [[pointToNum(x-a, y-a) for x in range(2*a+1)] for y in range(2*a+1)]


#Also, make an array with values measuring "how prime" using sum of divisor;
# if it is prime the value will be zero
ulamArrayDivisors = [[sigma(pointToNum(x-a, y-a),0)-2 for x in range(2*a+1)] for y in range(2*a+1)]

#create array of abundant numbers
ulamArrayAbundant = [[float(sigma(pointToNum(x-a, y-a))/pointToNum(x-a, y-a)) >2 for x in range(2*a+1)] for y in range(2*a+1)]

#abundancy quotient
ulamArrayAbundantQ = [[float(sigma(pointToNum(x-a, y-a))/pointToNum(x-a, y-a))  for x in range(2*a+1)] for y in range(2*a+1)]

def plotFromArray(array,colormap):
    return matrix_plot(array,origin='lower',frame=False,cmap=colormap)
    
def ulamPrimeMake(size,name,colormap):
    a = size
    #Now identify the primes
    ulamArrayPrimes = [[pointToNum(x-a, y-a) not in Primes() for x in range(2*a+1)] for y in range(2*a+1)]
    plot = plotFromArray(ulamArrayPrimes,colormap)
    plotName=name+'.pdf'
    plot.save(filename=plotName)

def ulamAbundantMake(size,name,colormap):   
    a = size
    #Now identify the primes
    ulamArray = [[float(sigma(pointToNum(x-a, y-a))/pointToNum(x-a, y-a))>2  for x in range(2*a+1)] for y in range(2*a+1)]
    plot = plotFromArray(ulamArray,colormap)
    plotName=name+'.pdf'
    plot.save(filename=plotName)
    
def ulamPrimeMake(size,name,colormap):   
    a = size
    #Now identify the primes
    ulamArray = [[pointToNum(x-a, y-a) not in Primes() for x in range(2*a+1)] for y in range(2*a+1)]
    plot = plotFromArray(ulamArray,colormap)
    plotName=name+'.pdf'
    plot.save(filename=plotName)
    
def ulamNotPrimeMake(size,name,colormap):   
    a = size
    #Now identify the primes
    ulamArray = [[pointToNum(x-a, y-a) in Primes() for x in range(2*a+1)] for y in range(2*a+1)]
    plot = plotFromArray(ulamArray,colormap)
    plotName=name+'.pdf'
    plot.save(filename=plotName)

def relPrimeMake(size,name,colormap):
    relPrimeArray=[[gcd(x,y)!=1 for x in [1..size]] for y in [1..size]]
    plot=matrix_plot(relPrimeArray,origin='lower',frame=False,cmap=colormap)
    plotName=name+'.pdf'
    plot.save(filename=plotName,frame=False)
    
def notRelPrimeMake(size,name,colormap):
    relPrimeArray=[[gcd(x,y)==1 for x in [1..size]] for y in [1..size]]
    plot=matrix_plot(relPrimeArray,origin='lower',frame=False,cmap=colormap)
    plotName=name+'.pdf'
    plot.save(filename=plotName,frame=False)
︡3e5219e7-ddfb-42a8-901f-3a5065a35d6e︡{"done":true}
︠fe484aea-d783-4a84-bfef-32a42e2ae3f2s︠
ulamPrimeMake(100,'prime100','winter')
︡3b5a0dcb-8a1b-4b31-9c5e-89c08d2b5d7d︡{"done":true}
︠8578caa9-74bc-481f-b50b-1fbacc2e9b25s︠
def ulamRandomMake(size,name,colormap):
    a = size
    #Now identify the primes
    ulamArrayPrimes = [[ (random()>1/float(log(2+pointToNum(x-a, y-a)))) for x in range(2*a+1)] for y in range(2*a+1)]
    plot = plotFromArray(ulamArrayPrimes,colormap)
    plotName=name+'.pdf'
    plot.save(filename=plotName)
︡00e6d633-0e5a-496c-92f8-250d09ed7e8d︡{"done":true}
︠d9983726-6abe-4d5d-aeee-e1efc01b87bbs︠
for k in [1..40]:
    print k, k^2-k+41, (k^2-k+41).is_prime()
︡2b5f862f-54c9-4f74-9727-c70774839cb3︡{"stdout":"1 41 True\n2 43 True\n3 47 True\n4 53 True\n5 61 True\n6 71 True\n7 83 True\n8 97 True\n9 113 True\n10 131 True\n11 151 True\n12 173 True\n13 197 True\n14 223 True\n15 251 True\n16 281 True\n17 313 True\n18 347 True\n19 383 True\n20 421 True\n21 461 True\n22 503 True\n23 547 True\n24 593 True\n25 641 True\n26 691 True\n27 743 True\n28 797 True\n29 853 True\n30 911 True\n31 971 True\n32 1033 True\n33 1097 True\n34 1163 True\n35 1231 True\n36 1301 True\n37 1373 True\n38 1447 True\n39 1523 True\n40 1601 True\n"}︡{"done":true}
︠bf6c5d2f-b332-4164-a120-40a3a105e3d7︠
n=1000000

sum([(k^2-k+41).is_prime() for k in [1..n]])
︡9f7a63a2-4b7d-4aca-ac1b-740540ea06da︡
︠6709304a-0926-434b-883d-1a5aa32d4775s︠
a=2
n=10000
powers = [a^k for k in range(n)]
lastDigits = [powers[i].digits()[-1] for i in range(n)]
[lastDigits.count(j) for j in [1..9]]
︡add62363-5dea-4c68-b3a4-edf8818ae6b1︡{"stdout":"[3010, 1761, 1249, 970, 791, 670, 579, 512, 458]\n"}︡{"done":true}
︠ce8979ab-a81c-4ad2-8a68-ec5fdd9b4bf2s︠
mylist=[7,7,7]
mlen=len(mylist)
matchlist=[]
for n in [10..999]:
    testlist=powers[n].digits()
    tlen=len(testlist)
    result=false
    for i in [0..tlen-mlen-1]:
        if testlist[i:i+mlen]==mylist:
            result=true
            matchlist.append(n)
            break
matchlist
︡ceabec8c-61dd-4ac2-ab85-497f34f97323︡{"stdout":"[24, 40, 75, 152, 166, 179, 181, 191, 194, 199, 214, 230, 235, 260, 296, 304, 311, 317, 323, 326, 332, 342, 345, 363, 370, 374, 390, 417, 424, 426, 443, 455, 468, 471, 474, 475, 483, 489, 490, 505, 512, 523, 524, 536, 540, 559, 567, 581, 584, 585, 588, 593, 608, 609, 611, 618, 620, 626, 632, 643, 645, 649, 650, 651, 653, 660, 663, 669, 670, 678, 689, 692, 693, 694, 695, 696, 702, 704, 706, 710, 715, 717, 718, 721, 722, 743, 746, 756, 759, 763, 770, 775, 777, 781, 782, 787, 791, 799, 801, 807, 816, 818, 819, 824, 828, 830, 837, 851, 863, 867, 880, 883, 902, 906, 909, 922, 925, 927, 930, 931, 944, 954, 958, 967, 969, 972, 973, 974, 975, 978, 981, 984, 985, 987, 991, 992, 997]\n"}︡{"done":true}
︠2a520dcc-2d5d-4b29-83b0-bde3ae145f5d︠










